package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WXAccount;
import com.sa.ibiz.demo.demo.domain.WXEntApp;

/**
 * 实体[WXMedia] 数据对象
 */
@TableName(value = "T_SRFWXMEDIA",resultMap = "WXMediaResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WXMedia extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WXAccount wxaccount;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WXEntApp wxentapp;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wxaccountid;
    private String wxaccountname;
    private String wxentappid;
    private String wxentappname;
    @TableId(value= "wxmediaid",type=IdType.UUID)//指定主键生成策略
    private String wxmediaid;
    private String wxmedianame;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountid
     */
    public void setWxaccountid(String wxaccountid){
        if(StringUtils.isEmpty(wxaccountid))
            wxaccountid=null;
        this.wxaccountid = wxaccountid;
        this.set("wxaccountiddirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountid(){
        return this.wxaccountid;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountid(){
        this.set("wxaccountiddirtyflag",false);
        this.wxaccountid = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountname
     */
    public void setWxaccountname(String wxaccountname){
        if(StringUtils.isEmpty(wxaccountname))
            wxaccountname=null;
        this.wxaccountname = wxaccountname;
        this.set("wxaccountnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wxaccountname)&&(!StringUtils.isEmpty(this.getWxaccountid())) && this.getWxaccount()!=null)
        {
            this.wxaccountname = this.getWxaccount().getWxaccountname();
            this.set("wxaccountnamedirtyflag",true);
        }
        return this.wxaccountname;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountname(){
        this.set("wxaccountnamedirtyflag",false);
        this.wxaccountname = null;
    }
    /**
     *  设置属性值[微信企业应用]
     *  @param wxentappid
     */
    public void setWxentappid(String wxentappid){
        if(StringUtils.isEmpty(wxentappid))
            wxentappid=null;
        this.wxentappid = wxentappid;
        this.set("wxentappiddirtyflag",true);
    }
    /**
     *  获取属性值[微信企业应用]
     */
    public String getWxentappid(){
        return this.wxentappid;
    }
    /**
     *  重置属性值[微信企业应用]
     */
    public void resetWxentappid(){
        this.set("wxentappiddirtyflag",false);
        this.wxentappid = null;
    }
    /**
     *  设置属性值[微信企业应用]
     *  @param wxentappname
     */
    public void setWxentappname(String wxentappname){
        if(StringUtils.isEmpty(wxentappname))
            wxentappname=null;
        this.wxentappname = wxentappname;
        this.set("wxentappnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信企业应用]
     */
    public String getWxentappname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wxentappname)&&(!StringUtils.isEmpty(this.getWxentappid())) && this.getWxentapp()!=null)
        {
            this.wxentappname = this.getWxentapp().getWxentappname();
            this.set("wxentappnamedirtyflag",true);
        }
        return this.wxentappname;
    }
    /**
     *  重置属性值[微信企业应用]
     */
    public void resetWxentappname(){
        this.set("wxentappnamedirtyflag",false);
        this.wxentappname = null;
    }
    /**
     *  设置属性值[微信多媒体内容标识]
     *  @param wxmediaid
     */
    public void setWxmediaid(String wxmediaid){
        if(StringUtils.isEmpty(wxmediaid))
            wxmediaid=null;
        this.wxmediaid = wxmediaid;
        this.set("wxmediaiddirtyflag",true);
    }
    /**
     *  获取属性值[微信多媒体内容标识]
     */
    public String getWxmediaid(){
        return this.wxmediaid;
    }
    /**
     *  重置属性值[微信多媒体内容标识]
     */
    public void resetWxmediaid(){
        this.set("wxmediaiddirtyflag",false);
        this.wxmediaid = null;
    }
    /**
     *  设置属性值[微信多媒体内容名称]
     *  @param wxmedianame
     */
    public void setWxmedianame(String wxmedianame){
        if(StringUtils.isEmpty(wxmedianame))
            wxmedianame=null;
        this.wxmedianame = wxmedianame;
        this.set("wxmedianamedirtyflag",true);
    }
    /**
     *  获取属性值[微信多媒体内容名称]
     */
    public String getWxmedianame(){
        return this.wxmedianame;
    }
    /**
     *  重置属性值[微信多媒体内容名称]
     */
    public void resetWxmedianame(){
        this.set("wxmedianamedirtyflag",false);
        this.wxmedianame = null;
    }
     /**
     *  获取主实体关联数据[WXAccount]
     */
    public WXAccount getWxaccount() {
        return wxaccount;
    }
    /**
     *  设置主实体关联数据[WXAccount]
     */
    public void setWxaccount(WXAccount wxaccount) {
        this.wxaccount = wxaccount;
    }

     /**
     *  获取主实体关联数据[WXEntApp]
     */
    public WXEntApp getWxentapp() {
        return wxentapp;
    }
    /**
     *  设置主实体关联数据[WXEntApp]
     */
    public void setWxentapp(WXEntApp wxentapp) {
        this.wxentapp = wxentapp;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetWxaccountid();
        resetWxaccountname();
        resetWxentappid();
        resetWxentappname();
        resetWxmediaid();
        resetWxmedianame();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WXMedia copyTo(WXMedia targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WXMedia.class, WXMedia.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWxmediaid();
		return targetEntity;
	}
}